// Code generated by Node.js. DO NOT EDIT.

package npm

var (
	autoGeneratedTests = []struct {
		version    string
		constraint string
		want       bool
	}{
		{"1.2.3", "=2.0.0", false},
		{"2.0.0", "=2.0.0", true},
		{"1.2.3", "=2.0", false},
		{"2.0.0", "=2.0", true},
		{"2.0.1", "=2.0", true},
		{"1.0.0", "=0", false},
		{"4.1.0", "4.1", true},
		{"1.0.0", "2", false},
		{"3.4.5", "2", false},
		{"2.1.1", "2", true},
		{"2.1.1", "2.1", true},
		{"2.2.1", "2.1", false},
		{"0.1.0", "<11", true},
		{"11.1.0", "<11", false},
		{"0.1.0", "<1.1", true},
		{"1.1.0", "<1.1", false},
		{"1.1.1", "<1.1", false},
		{"1.2.2", "<1.2.3", true},
		{"1.2.3-alpha", "<1.2.3-beta", true},
		{"1.2.2-alpha", "<1.2.3-beta", false},
		{"1.2.2", "<1.2.3-beta", true},
		{"0.0.0-alpha", "<0", false},
		{"0.0.0-alpha", "<0-z", false},
		{"0.0.0-alpha", "<0.0.0-z", true},
		{"1.2.3", "<=11", true},
		{"12.2.3", "<=11", false},
		{"11.2.3", "<=11", true},
		{"1.2.3", "<=1.1", false},
		{"0.1.0", "<=1.1", true},
		{"1.1.0", "<=1.1", true},
		{"1.1.1", "<=1.1", true},
		{"1.2.3-beta", "<=1.2.3-beta", true},
		{"1.2.3-alpha", "<=1.2.3-beta", true},
		{"1.2.2-alpha", "<=1.2.3-beta", false},
		{"1.2.2", "<=1.2.3-beta", true},
		{"4.1.0", ">1.1", true},
		{"1.1.0", ">1.1", false},
		{"0.0.0", ">0", false},
		{"1.0.0", ">0", true},
		{"0.0.1-alpha", ">0", false},
		{"0.0.1-alpha", ">0.0", false},
		{"0.0.1-alpha", ">0-0", false},
		{"0.0.1-alpha", ">0.0-0", false},
		{"0.0.0-alpha", ">0", false},
		{"0.0.0-alpha", ">0-0", false},
		{"0.0.0-alpha", ">0.0.0-0", true},
		{"0.0.0-alpha", ">0.0.0-0", true},
		{"1.2.3-alpha.2", ">1.2.3-alpha.1", true},
		{"1.3.3-alpha.2", ">1.2.3-alpha.1", false},
		{"11.1.0", ">11", false},
		{"11.1.0", ">11.1", false},
		{"11.1.1", ">11.1", false},
		{"11.2.1", ">11.1", true},
		{"11.1.2", ">=11", true},
		{"11.1.2", ">=11.1", true},
		{"11.0.2", ">=11.1", false},
		{"4.1.0", ">=1.1", true},
		{"1.1.0", ">=1.1", true},
		{"0.0.9", ">=1.1", false},
		{"0.0.1-alpha", ">=0", false},
		{"0.0.1-alpha", ">=0.0", false},
		{"0.0.1-alpha", ">=0-0", false},
		{"0.0.1-alpha", ">=0.0-0", false},
		{"0.0.0-alpha", ">=0", false},
		{"0.0.0-alpha", ">=0-0", false},
		{"0.0.0-alpha", ">=0.0.0-0", true},
		{"1.2.3", ">=0.0.0-0", true},
		{"3.4.5-beta.1", ">=0.0.0-0", false},
		{"0.0.0", ">=0", true},
		{"1.2.3-alpha.1", ">=1.2.3-alpha.1", true},
		{"1.2.3-alpha.2", ">=1.2.3-alpha.1", true},
		{"1.3.3-alpha.2", ">=1.2.3-alpha.1", false},
		{"1.0.0", "*", true},
		{"4.5.6", "*", true},
		{"1.2.3-alpha.1", "*", false},
		{"1.0.0", "2.*", false},
		{"3.4.5", "2.*", false},
		{"2.1.1", "2.*", true},
		{"2.1.1", "2.1.*", true},
		{"2.2.1", "2.1.*", false},
		{"1.0.0", "", true},
		{"4.5.6", "", true},
		{"1.2.3-alpha.1", "", false},
		{"1.2.4", "~1.2.3", true},
		{"1.3.4", "~1.2.3", false},
		{"1.2.4", "~1.2", true},
		{"1.3.4", "~1.2", false},
		{"1.2.4", "~1", true},
		{"2.3.4", "~1", false},
		{"0.2.5", "~0.2.3", true},
		{"0.3.5", "~0.2.3", false},
		{"0.2.0", "~0.2", true},
		{"0.2.1", "~0.2", true},
		{"0.3.0", "~0.2", false},
		{"0.3.0-alpha", "~0.2", false},
		{"0.0.0", "~0", true},
		{"0.1.2", "~0", true},
		{"1.0.0", "~0", false},
		{"1.0.0-beta", "~0", false},
		{"1.2.3-beta.4", "~1.2.3-beta.2", true},
		{"1.2.4-beta.2", "~1.2.3-beta.2", false},
		{"1.3.4-beta.2", "~1.2.3-beta.2", false},
		{"1.8.9", "^1.2.3", true},
		{"2.8.9", "^1.2.3", false},
		{"1.2.1", "^1.2.3", false},
		{"2.1.0", "^1.1.0", false},
		{"2.2.1", "^1.2.0", false},
		{"1.2.1-alpha.1", "^1.2.0", false},
		{"1.2.1-alpha.1", "^1.2.0-alpha.0", false},
		{"1.2.1-alpha.0", "^1.2.0-alpha.0", false},
		{"1.2.0-alpha.1", "^1.2.0-alpha.2", false},
		{"1.8.9", "^1.2", true},
		{"2.8.9", "^1.2", false},
		{"1.8.9", "^1", true},
		{"2.8.9", "^1", false},
		{"0.2.5", "^0.2.3", true},
		{"0.5.6", "^0.2.3", false},
		{"0.2.5", "^0.2", true},
		{"0.5.6", "^0.2", false},
		{"0.0.3", "^0.0.3", true},
		{"0.0.4", "^0.0.3", false},
		{"0.0.3", "^0.0", true},
		{"0.1.4", "^0.0", false},
		{"1.0.4", "^0.0", false},
		{"0.2.3", "^0", true},
		{"1.1.4", "^0", false},
		{"1.0.0", "^1.2.x", false},
		{"1.2.0", "^1.2.x", true},
		{"2.0.0", "^1.2.x", false},
		{"0.0.0", "^0.0.x", true},
		{"0.0.1", "^0.0.x", true},
		{"0.1.0", "^0.0.x", false},
		{"1.0.0", "^1.x", true},
		{"1.2.3", "^1.x", true},
		{"2.0.0", "^1.x", false},
		{"0.0.0", "^0.x", true},
		{"0.1.2", "^0.x", true},
		{"1.0.0", "^0.x", false},
		{"0.2.3-beta.4", "^0.2.3-beta.2", true},
		{"0.2.4-beta.2", "^0.2.3-beta.2", false},
		{"0.3.4-beta.2", "^0.2.3-beta.2", false},
		{"0.2.3-beta.2", "^0.2.3-beta.2", true},
		{"1.2.4", ">1.2.3 <2.0.0", true},
		{"2.0.0", ">1.2.3 <2.0.0", false},
		{"3.0.0", ">1.2.3 <2.0.0 || >3.0.0", false},
		{"4.0.0", ">1.2.3 <2.0.0 || >3.0.0", true},
		{"4.0.0", "> 1.2.3 < 2.0.0 || > 3.0.0", true},
		{"4.0.0", "<1.2.3 || > 3.0.0 < 4.0.0", false},
		{"4.0.0", "<1.2.3 || > 3.0.0 <= 4.0.0", true},
	}
)
