// Code generated by smithy-go-codegen DO NOT EDIT.

package workspaces

import (
	"context"
	"fmt"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/service/workspaces/types"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// Describes the associations between the application and the specified associated
// resources.
func (c *Client) DescribeApplicationAssociations(ctx context.Context, params *DescribeApplicationAssociationsInput, optFns ...func(*Options)) (*DescribeApplicationAssociationsOutput, error) {
	if params == nil {
		params = &DescribeApplicationAssociationsInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "DescribeApplicationAssociations", params, optFns, c.addOperationDescribeApplicationAssociationsMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*DescribeApplicationAssociationsOutput)
	out.ResultMetadata = metadata
	return out, nil
}

type DescribeApplicationAssociationsInput struct {

	// The identifier of the specified application.
	//
	// This member is required.
	ApplicationId *string

	// The resource type of the associated resources.
	//
	// This member is required.
	AssociatedResourceTypes []types.ApplicationAssociatedResourceType

	// The maximum number of associations to return.
	MaxResults *int32

	// If you received a NextToken from a previous call that was paginated, provide
	// this token to receive the next set of results.
	NextToken *string

	noSmithyDocumentSerde
}

type DescribeApplicationAssociationsOutput struct {

	// List of associations and information about them.
	Associations []types.ApplicationResourceAssociation

	// If you received a NextToken from a previous call that was paginated, provide
	// this token to receive the next set of results.
	NextToken *string

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationDescribeApplicationAssociationsMiddlewares(stack *middleware.Stack, options Options) (err error) {
	if err := stack.Serialize.Add(&setOperationInputMiddleware{}, middleware.After); err != nil {
		return err
	}
	err = stack.Serialize.Add(&awsAwsjson11_serializeOpDescribeApplicationAssociations{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsAwsjson11_deserializeOpDescribeApplicationAssociations{}, middleware.After)
	if err != nil {
		return err
	}
	if err := addProtocolFinalizerMiddlewares(stack, options, "DescribeApplicationAssociations"); err != nil {
		return fmt.Errorf("add protocol finalizers: %v", err)
	}

	if err = addlegacyEndpointContextSetter(stack, options); err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = addClientRequestID(stack); err != nil {
		return err
	}
	if err = addComputeContentLength(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = addComputePayloadSHA256(stack); err != nil {
		return err
	}
	if err = addRetry(stack, options); err != nil {
		return err
	}
	if err = addRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = addRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addSetLegacyContextSigningOptionsMiddleware(stack); err != nil {
		return err
	}
	if err = addOpDescribeApplicationAssociationsValidationMiddleware(stack); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opDescribeApplicationAssociations(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = addRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	if err = addDisableHTTPSMiddleware(stack, options); err != nil {
		return err
	}
	return nil
}

// DescribeApplicationAssociationsAPIClient is a client that implements the
// DescribeApplicationAssociations operation.
type DescribeApplicationAssociationsAPIClient interface {
	DescribeApplicationAssociations(context.Context, *DescribeApplicationAssociationsInput, ...func(*Options)) (*DescribeApplicationAssociationsOutput, error)
}

var _ DescribeApplicationAssociationsAPIClient = (*Client)(nil)

// DescribeApplicationAssociationsPaginatorOptions is the paginator options for
// DescribeApplicationAssociations
type DescribeApplicationAssociationsPaginatorOptions struct {
	// The maximum number of associations to return.
	Limit int32

	// Set to true if pagination should stop if the service returns a pagination token
	// that matches the most recent token provided to the service.
	StopOnDuplicateToken bool
}

// DescribeApplicationAssociationsPaginator is a paginator for
// DescribeApplicationAssociations
type DescribeApplicationAssociationsPaginator struct {
	options   DescribeApplicationAssociationsPaginatorOptions
	client    DescribeApplicationAssociationsAPIClient
	params    *DescribeApplicationAssociationsInput
	nextToken *string
	firstPage bool
}

// NewDescribeApplicationAssociationsPaginator returns a new
// DescribeApplicationAssociationsPaginator
func NewDescribeApplicationAssociationsPaginator(client DescribeApplicationAssociationsAPIClient, params *DescribeApplicationAssociationsInput, optFns ...func(*DescribeApplicationAssociationsPaginatorOptions)) *DescribeApplicationAssociationsPaginator {
	if params == nil {
		params = &DescribeApplicationAssociationsInput{}
	}

	options := DescribeApplicationAssociationsPaginatorOptions{}
	if params.MaxResults != nil {
		options.Limit = *params.MaxResults
	}

	for _, fn := range optFns {
		fn(&options)
	}

	return &DescribeApplicationAssociationsPaginator{
		options:   options,
		client:    client,
		params:    params,
		firstPage: true,
		nextToken: params.NextToken,
	}
}

// HasMorePages returns a boolean indicating whether more pages are available
func (p *DescribeApplicationAssociationsPaginator) HasMorePages() bool {
	return p.firstPage || (p.nextToken != nil && len(*p.nextToken) != 0)
}

// NextPage retrieves the next DescribeApplicationAssociations page.
func (p *DescribeApplicationAssociationsPaginator) NextPage(ctx context.Context, optFns ...func(*Options)) (*DescribeApplicationAssociationsOutput, error) {
	if !p.HasMorePages() {
		return nil, fmt.Errorf("no more pages available")
	}

	params := *p.params
	params.NextToken = p.nextToken

	var limit *int32
	if p.options.Limit > 0 {
		limit = &p.options.Limit
	}
	params.MaxResults = limit

	result, err := p.client.DescribeApplicationAssociations(ctx, &params, optFns...)
	if err != nil {
		return nil, err
	}
	p.firstPage = false

	prevToken := p.nextToken
	p.nextToken = result.NextToken

	if p.options.StopOnDuplicateToken &&
		prevToken != nil &&
		p.nextToken != nil &&
		*prevToken == *p.nextToken {
		p.nextToken = nil
	}

	return result, nil
}

func newServiceMetadataMiddleware_opDescribeApplicationAssociations(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		OperationName: "DescribeApplicationAssociations",
	}
}
